using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;

using BeWo.Core;
using BeWo.ServiceProxy;
using BeWo.Validation;
using BeWo.ViewModel;
using BeWo.ViewModel.ListViewModel;

using BS.Shared.Extensions;

namespace BeWo.View.Detail
{
	public partial class AuszahlungsartenAddView
	{
		private AuszahlungsartListVM _ViewModel;

		public AuszahlungsartenAddView(AuszahlungsartListVM pViewModel)
		{
			InitializeComponent();
			ViewModel = pViewModel;
		}

		public override bool IsDirty
		{
			get { return ViewModel != null && ViewModel.IsDirty; }
		}

		public override string Title
		{
			get { return "Auszahlungsarten"; }
		}

		private AuszahlungsartListVM ViewModel
		{
			get { return _ViewModel; }

			set
			{
				_ViewModel = value;
				root.DataContext = value;
			}
		}

		internal override DependencyObject ValidationOnSaveRootElement
		{
			get { return button_addAuszahlungsart; }
		}

		protected override void Save()
		{
			var lToDos = new List<Action<IEmployeeService>>();

			if (ViewModel.RemovedCount > 0)
			{
				lToDos.Add(s => s.DeleteAuszahlungsarten(ViewModel.GetRemoved().ToDictionary(dc => dc.AuszahlungsartOid.Value, dc => dc.AuszahlungsartVersion.Value)));
			}

			if (ViewModel.AddedCount > 0)
			{
				lToDos.Add(s => s.InsertAuszahlungsarten(ViewModel.CommitAdded()));
			}

			if (ViewModel.ChangedCount > 0)
			{
				lToDos.Add(s => s.UpdateAuszahlungsarten(ViewModel.CommitChanged()));
			}

			ServiceFacade.DoMultipleEmployeeServicesAsync(lToDos, ReloadViewModel);
		}

		private void ReloadViewModel()
		{
			VMFactory.CreateAuszahlungsartenListVMAsync(r => this.Dispatch(delegate { ViewModel = r; }));
		}

		private void button_addAuszahlungsart_Click(object sender, RoutedEventArgs e)
		{
			if (ValidationTrigger.Validate(this))
			{
				ViewModel.AddNewVMToList();
			}
		}

		private void DeleteButton_Click(object sender, RoutedEventArgs e)
		{
			var lVM = DatagridServices.GetCurrentValue<AuszahlungsartVM>();
			if (lVM == null)
				return;

			ViewModel.VMList.Remove(lVM);
			BeWoWpfUtils.RefreshDXGrid(DatagridServices);
		}
	}
}
